using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing.Design;
using System.Windows.Forms.Design;
using System.Windows.Forms;

namespace HelpLibrary
{
    class HelpEditor : UITypeEditor
    {

        public override UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.DropDown;
        }

        public override object EditValue(System.ComponentModel.ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            if ((context != null) && (provider !=  null)) {
                IWindowsFormsEditorService editorService =
                    (IWindowsFormsEditorService)
                provider.GetService(typeof(IWindowsFormsEditorService));

                if (editorService != null)
                {
                    HelpEditorControl textBox = 
                        new HelpEditorControl(editorService);
                    textBox.HelpString = (String)value;
                    editorService.DropDownControl(textBox);
                    return textBox.HelpString;
                }
            }
            return base.EditValue(context, provider, value);
        }


    }
}
