using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.Design;

namespace HelpLibrary
{
    public partial class HelpEditorControl : UserControl
    {
        IWindowsFormsEditorService editorService = null;
        public HelpEditorControl(IWindowsFormsEditorService editorService)
        {
            InitializeComponent();
            this.editorService = editorService;
        }

        [Category("Help")]
        [Description("Help String to show in editor.")]
        public String HelpString
        {
            get { return this.textBoxInput.Text; }
            set { this.textBoxInput.Text = value; }
        }

        private void textBoxInput_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.Enter:
                    if (e.Control)
                    {
                        editorService.CloseDropDown();
                    }
                    break;
            }
        }
    }
}
