using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace Utils4226
{
    public static class Conversion
    {
        public static float InchesToPixels(Control control, float inches)
        {
            using (Graphics g = control.CreateGraphics())
            {
                return inches * g.DpiY;
            }
        }

        public static float InchesToPixels(Graphics g, float inches)
        {
            return inches * g.DpiY;
        }

        public static float PointsToPixels(Control control, float inches)
        {
            using (Graphics g = control.CreateGraphics())
            {
                return inches / 72 * g.DpiY;
            }
        }

        public static float PointsToPixels(Graphics g, float points)
        {
            return points / 72 * g.DpiY;
        }

        public static float PointsToInches(float points)
        {
            return points / 72;
        }

        public static float Unscale(float scale, float value)
        {
            return value / scale;
        }

        public static float Scale(float scale, float value)
        {
            return value * scale;
        }

        public static RectangleF InchesToPixels(Control control, RectangleF rect)
        {
            using (Graphics g = control.CreateGraphics())
            {
                return new RectangleF(
                    InchesToPixels(g, rect.X), InchesToPixels(g, rect.Y),
                    InchesToPixels(g, rect.Width), InchesToPixels(g, rect.Height));
            }

        }

        public static RectangleF InchesToPixels(Graphics g, RectangleF rect)
        {
            return new RectangleF(InchesToPixels(g, rect.X), InchesToPixels(g, rect.Y),
                InchesToPixels(g, rect.Width), InchesToPixels(g, rect.Height));
        }

        public static float PixelsToInches(Control control, float pixels)
        {
            using (Graphics g = control.CreateGraphics())
            {
                return pixels / g.DpiX;
            }
        }

        public static float PixelsToInches(Graphics g, float pixels)
        {
            return pixels / g.DpiX;
        }
    }
}
