using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace BrushesSample
{
    public partial class ColorForm : Form
    {
        public ColorForm()
        {
            InitializeComponent();
        }

        private void ColorForm_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            string[] colorNames = Enum.GetNames(typeof(KnownColor));
            int x = 0;
            int y = 0;
            int width = this.ClientRectangle.Width / 4;
            int height = this.ClientRectangle.Height / ((colorNames.Length - 1) / 4 + 1);
            Brush blackBrush = System.Drawing.Brushes.Black;
            Pen blackPen = Pens.Black;

            Array.Sort(colorNames);

            foreach (string colorName in colorNames)
            {
                KnownColor knownColor = (KnownColor)Enum.Parse(typeof(KnownColor), colorName);
                Color color = Color.FromKnownColor(knownColor);
                using (Brush brush = new SolidBrush(color))
                {
                    g.FillRectangle(brush, x, y, width, height);
                    g.DrawRectangle(blackPen, x, y, width, height);
                    if (color.GetBrightness() > 0.45f)
                    {
                        g.DrawString(colorName, this.Font, blackBrush, x, y);
                    }
                    else
                    {
                        g.DrawString(colorName, this.Font, Brushes.White, x, y);
                    }
                    x += width;
                    if (x > this.ClientRectangle.Width - width)
                    {
                        y += height;
                        x = 0;
                    }
                }
            }
        }

    }
}