﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

#endregion

namespace ShapesSample
{
    partial class BeziersForm : Form
    {
        StringFormat format = new StringFormat();
        public BeziersForm()
        {
            InitializeComponent();
            format.Alignment = StringAlignment.Center;
            format.LineAlignment = StringAlignment.Center;
        }

        private int width;
        private int height;

        private void BeziersForm_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            width = this.ClientRectangle.Width / 3;
            height = this.ClientRectangle.Height / 2;
            Brush blackBrush = Brushes.Black;
            Brush fillBrush = Brushes.Gray;
            Pen whitePen = Pens.White;

            using (Pen pen = new Pen(Color.Red, 4))
            using (Pen pointPen = new Pen(Color.Black, 3))
            {
                pointPen.StartCap = pointPen.EndCap = LineCap.SquareAnchor;

                Point[] ptsAbs = new Point[] { 
                    new Point(25, 25), 
                    new Point(width - 25, 25),
                    new Point(25, height - 25), 
                    new Point(width - 25, height - 25),
                    new Point(width + 25, 25), 
                    new Point(2*width - 25, 25),
                    new Point(width + 25, height - 25), 
                    new Point(2*width - 25, height - 25),
                    new Point(2*width + 25, 25), 
                    new Point(3*width - 25, 25),
                    new Point(2*width + 25, height - 25), 
                    new Point(3*width - 25, height - 25)
                };

                Point[] points = new Point[] {ptsAbs[0], ptsAbs[1], ptsAbs[2], ptsAbs[3]};
                g.DrawBeziers(pen, points);
                g.DrawRectangle(Pens.Black, 0, 0, width, height);
                DrawPoints(g, this.Font, points, pointPen);

                g.TranslateTransform(width, 0);
                points = new Point[] { ptsAbs[0], ptsAbs[1], ptsAbs[3], ptsAbs[2] };
                g.DrawBeziers(pen, points);
                g.DrawRectangle(Pens.Black, 0, 0, width, height);
                DrawPoints(g, this.Font, points, pointPen);

                g.TranslateTransform(width, 0);
                points = new Point[] { ptsAbs[2], ptsAbs[3], ptsAbs[0], ptsAbs[1] };
                g.DrawBeziers(pen, points);
                g.DrawRectangle(Pens.Black, 0, 0, width, height);
                DrawPoints(g, this.Font, points, pointPen); 
                
                g.TranslateTransform(-2*width, height);
                points = new Point[] { 
                    ptsAbs[0], ptsAbs[1], ptsAbs[2], ptsAbs[3], 
                    ptsAbs[4], ptsAbs[6], ptsAbs[5],
                    ptsAbs[9], ptsAbs[10], ptsAbs[11]
                };
                g.DrawBeziers(pen, points);
                g.DrawRectangle(Pens.Black, 0, 0, width*3, height);
                DrawPoints(g, this.Font, points, pointPen);
            }
        }

        public static void DrawPoints(Graphics g, Font font, Point[] points, Pen pen)
        {
            foreach (Point point in points)
                g.DrawLine(pen, new Point(point.X, point.Y), new Point(point.X + 1, point.Y));
            for (int i = 0; i != points.Length; ++i)
                g.DrawString(i.ToString(), font, Brushes.Black, points[i]);
        }
    }
}