﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

#endregion

namespace ShapesSample
{
    partial class CurvesForm : Form
    {
        StringFormat format = new StringFormat();
        public CurvesForm()
        {
            InitializeComponent();
            format.Alignment = StringAlignment.Center;
            format.LineAlignment = StringAlignment.Far;
        }

        private void CurvesForm_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            int width = this.ClientRectangle.Width / 3;
            int height = this.ClientRectangle.Height;
            int fontHeight = this.Font.Height;

            using (Pen pen = new Pen(Color.Red, 4))
            using (Pen pointPen = new Pen(Color.Black, 3))
            {
                pointPen.StartCap = pointPen.EndCap = LineCap.SquareAnchor;

                float tension = 0;
                Point[] points = null;
                Rectangle rectDraw =
                    new Rectangle(0, 0, width, height - fontHeight - 10);
                Rectangle rectText =
                    new Rectangle(0, height - fontHeight - 10, width, fontHeight + 10);

                // Render 4-point curve with tension 0
                tension = 0.0f;
                points = new Point[] { 
                    new Point(25, height - fontHeight - 10 - 25), 
                    new Point(width - 25, height - fontHeight - 10 - 25), 
                    new Point(25, 25), 
                    new Point(width - 25, 25)
                };
                g.DrawRectangle(Pens.Black, rectDraw);
                g.DrawCurve(pen, points, tension);
                g.DrawString(
                    String.Format("Tension = {0}", tension), 
                    this.Font, Brushes.Black, rectText, format);
                BeziersForm.DrawPoints(g, this.Font, points, pointPen);

                // Render 4-point curve with tension 0.5
                tension = 0.5f;
                g.TranslateTransform(width, 0);
                g.DrawRectangle(Pens.Black, rectDraw);
                g.DrawCurve(pen, points, tension);
                g.DrawString(
                    String.Format("Tension = {0}", tension),
                    this.Font, Brushes.Black, rectText, format);
                BeziersForm.DrawPoints(g, this.Font, points, pointPen);

                // Render 4-point curve with tension 1.0
                tension = 1.0f;
                g.TranslateTransform(width, 0);
                g.DrawRectangle(Pens.Black, rectDraw);
                g.DrawCurve(pen, points, tension);
                g.DrawString(
                    String.Format("Tension = {0}", tension),
                    this.Font, Brushes.Black, rectText, format);
                BeziersForm.DrawPoints(g, this.Font, points, pointPen);
            }
        }

    }
}