﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

#endregion

namespace ShapesSample
{
    partial class FillModesForm : Form
    {

        StringFormat format = new StringFormat();
        public FillModesForm()
        {
            InitializeComponent();
            format.Alignment = StringAlignment.Center;
            format.LineAlignment = StringAlignment.Center;
        }

        private void FillModesForm_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            int width = this.ClientRectangle.Width / 2;
            int height = this.ClientRectangle.Height;

            using (Pen pen = new Pen(Color.Red, 4))
            using (Pen pointPen = new Pen(Color.Black, 3))
            {
                pointPen.StartCap = pointPen.EndCap = LineCap.SquareAnchor;
                FillMode fill = FillMode.Winding;
                Point[] points =  new Point[] { 
                    new Point(70, 70), 
                    new Point(70, height - 25), 
                    new Point(width / 2, 25), 
                    new Point(width / 2, height / 2), 
                    new Point(25, height - 70), 
                    new Point(width - 25, height - 25), 
                    new Point(width - 25, 70) 
                };
                Rectangle rectDraw = new Rectangle(0, 0, width, height);

                fill = FillMode.Winding;
                g.DrawRectangle(Pens.Black, rectDraw);
                g.FillPolygon(Brushes.DarkGray, points, fill);
                g.DrawPolygon(pen, points);
                g.DrawString(string.Format("FillMode= {0}", fill), 
                    this.Font, Brushes.Black, rectDraw, format);
                BeziersForm.DrawPoints(g, this.Font, points, pointPen);
                
                fill = FillMode.Alternate;
                g.TranslateTransform(width, 0);
                g.DrawRectangle(Pens.Black, rectDraw);
                g.FillPolygon(Brushes.DarkGray, points, fill);
                g.DrawPolygon(pen, points);
                g.DrawString(string.Format("FillMode= {0}", fill),
                    this.Font, Brushes.Black, rectDraw, format);
                BeziersForm.DrawPoints(g, this.Font, points, pointPen);
                
            }
        }
    }
}