﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

#endregion

namespace ShapesSample
{
    partial class SmoothingModesForm : Form
    {
        StringFormat format = new StringFormat();
        public SmoothingModesForm()
        {
            InitializeComponent();
            format.Alignment = StringAlignment.Center;
            format.LineAlignment = StringAlignment.Far;
        }

        private void SmoothingModesForm_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            int width = this.ClientRectangle.Width / 2;
            int height = this.ClientRectangle.Height;
            int fontHeight = this.FontHeight;

            Point[] points = new Point[] { 
                new Point(50, height - fontHeight - 50), 
                new Point(width - 50, height - fontHeight - 50), 
                new Point(50, 50), 
                new Point(width - 50, 50)
            };

            Rectangle rectText = new Rectangle(0, 0, width, height);

            using (Pen pen = new Pen(Color.Red, 4))
            {

                g.SmoothingMode = SmoothingMode.None;
                g.DrawCurve(pen, points, 1.0f);
                g.DrawString(g.SmoothingMode.ToString(), this.Font, Brushes.Black,
                    rectText, format);

                g.TranslateTransform(width, 0);
                g.SmoothingMode = SmoothingMode.AntiAlias;
                g.DrawCurve(pen, points, 1.0f);
                g.DrawString(g.SmoothingMode.ToString(), this.Font, Brushes.Black,
                    rectText, format);
            }
        }
    }
}