using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Globalization;

namespace Fonts
{
    /// <summary>
    /// Summary description for DigitSubstitutionForm.
    /// </summary>
    public class DigitSubstitutionForm : System.Windows.Forms.Form
    {
        private MenuStrip menuStrip1;
        private ToolStripComboBox toolStripComboBoxCulture;
        private Panel panelDraw;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        public DigitSubstitutionForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.menuStrip1 = new System.Windows.Forms.MenuStrip();
            this.panelDraw = new System.Windows.Forms.Panel();
            this.toolStripComboBoxCulture = new System.Windows.Forms.ToolStripComboBox();
            this.menuStrip1.SuspendLayout();
            this.SuspendLayout();
            // 
            // menuStrip1
            // 
            this.menuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripComboBoxCulture});
            this.menuStrip1.Location = new System.Drawing.Point(0, 0);
            this.menuStrip1.Name = "menuStrip1";
            this.menuStrip1.Size = new System.Drawing.Size(292, 25);
            this.menuStrip1.TabIndex = 0;
            this.menuStrip1.Text = "menuStrip1";
            // 
            // panelDraw
            // 
            this.panelDraw.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panelDraw.Location = new System.Drawing.Point(0, 25);
            this.panelDraw.Name = "panelDraw";
            this.panelDraw.Size = new System.Drawing.Size(292, 241);
            this.panelDraw.TabIndex = 1;
            this.panelDraw.Paint += new System.Windows.Forms.PaintEventHandler(this.panelDraw_Paint);
            // 
            // toolStripComboBoxCulture
            // 
            this.toolStripComboBoxCulture.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.toolStripComboBoxCulture.Name = "toolStripComboBoxCulture";
            this.toolStripComboBoxCulture.Size = new System.Drawing.Size(121, 21);
            this.toolStripComboBoxCulture.SelectedIndexChanged += new System.EventHandler(this.toolStripComboBoxCulture_SelectedIndexChanged);
            // 
            // DigitSubstitutionForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(9, 22);
            this.BackColor = System.Drawing.Color.White;
            this.ClientSize = new System.Drawing.Size(292, 266);
            this.Controls.Add(this.panelDraw);
            this.Controls.Add(this.menuStrip1);
            this.Font = new System.Drawing.Font("Microsoft Sans Serif", 14F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.MainMenuStrip = this.menuStrip1;
            this.Name = "DigitSubstitutionForm";
            this.Text = "Digit Substitution";
            this.Load += new System.EventHandler(this.DigitSubstitutionForm_Load);
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.DigitSubstitutionForm_Paint);
            this.menuStrip1.ResumeLayout(false);
            this.menuStrip1.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        void DigitSubstitutionForm_Paint(object sender, PaintEventArgs e)
        {
        }

        private void DigitSubstitutionForm_Load(object sender, EventArgs e)
        {
            foreach (CultureInfo info in
                CultureInfo.GetCultures(CultureTypes.AllCultures))
            {
                toolStripComboBoxCulture.Items.Add(info);
            }
            toolStripComboBoxCulture.SelectedIndex = 0;
        }

        private void toolStripComboBoxCulture_SelectedIndexChanged(object sender, EventArgs e)
        {
            Invalidate(true);
        }

        private void panelDraw_Paint(object sender, PaintEventArgs e)
        {

            Graphics g = e.Graphics;
            string digits = @"0 1 2 3 4 5 6 7 8 9 0";

            float y = 0;
            CultureInfo culture = (CultureInfo)toolStripComboBoxCulture.SelectedItem;
            StringFormat format = new StringFormat();
            g.DrawString(culture.EnglishName, 
                this.Font, Brushes.Black, 0, 0, format);
            y = this.Font.GetHeight(g);

            foreach (StringDigitSubstitute method in 
                Enum.GetValues(typeof(StringDigitSubstitute)))
            {
                format.SetDigitSubstitution(culture.LCID, method);
                g.DrawString(method.ToString() + ": " + digits, 
                    this.Font, Brushes.Black, 0, y, format);
                y += this.Font.GetHeight(g);
            }

        }
    }
}
