using System;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Text;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Fonts {
  /// <summary>
  /// Summary description for FontSizes.
  /// </summary>
    public class FontSizesForm : System.Windows.Forms.Form
    {
      private MenuStrip menuStrip1;
      private ToolStripMenuItem chooseFontToolStripMenuItem;
        private ListView listBox1;
    /// <summary>
    /// Required designer variable.
    /// </summary>
    private System.ComponentModel.Container components = null;

    public FontSizesForm() {
      //
      // Required for Windows Form Designer support
      //
      InitializeComponent();

      //
      // TODO: Add any constructor code after InitializeComponent call
      //



      listBox1.Columns.Add("Field",
                           40,
                           HorizontalAlignment.Center);
        listBox1.Columns.Add("Value",
                            -2,
                            HorizontalAlignment.Center);
        listBox1.View = View.Details;
    }

    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    protected override void Dispose( bool disposing ) {
      if( disposing ) {
        if(components != null) {
          components.Dispose();
        }
      }
      base.Dispose( disposing );
    }

		#region Windows Form Designer generated code
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent() {
        this.menuStrip1 = new System.Windows.Forms.MenuStrip();
        this.chooseFontToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
        this.listBox1 = new System.Windows.Forms.ListView();
        this.menuStrip1.SuspendLayout();
        this.SuspendLayout();
        // 
        // menuStrip1
        // 
        this.menuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.chooseFontToolStripMenuItem});
        this.menuStrip1.Location = new System.Drawing.Point(0, 0);
        this.menuStrip1.Name = "menuStrip1";
        this.menuStrip1.Size = new System.Drawing.Size(737, 24);
        this.menuStrip1.TabIndex = 1;
        this.menuStrip1.Text = "menuStrip1";
        // 
        // chooseFontToolStripMenuItem
        // 
        this.chooseFontToolStripMenuItem.Name = "chooseFontToolStripMenuItem";
        this.chooseFontToolStripMenuItem.Size = new System.Drawing.Size(80, 20);
        this.chooseFontToolStripMenuItem.Text = "Choose Font";
        this.chooseFontToolStripMenuItem.Click += new System.EventHandler(this.chooseFontToolStripMenuItem_Click);
        // 
        // listBox1
        // 
        this.listBox1.Dock = System.Windows.Forms.DockStyle.Fill;
        this.listBox1.Location = new System.Drawing.Point(0, 24);
        this.listBox1.Name = "listBox1";
        this.listBox1.Size = new System.Drawing.Size(737, 433);
        this.listBox1.TabIndex = 2;
        this.listBox1.UseCompatibleStateImageBehavior = false;
        // 
        // FontSizesForm
        // 
        this.AutoScaleBaseSize = new System.Drawing.Size(12, 22);
        this.ClientSize = new System.Drawing.Size(737, 457);
        this.Controls.Add(this.listBox1);
        this.Controls.Add(this.menuStrip1);
        this.Font = new System.Drawing.Font("Courier New", 14F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
        this.MainMenuStrip = this.menuStrip1;
        this.Name = "FontSizesForm";
        this.Text = "Font Sizes";
        this.Load += new System.EventHandler(this.FontSizes_Load);
        this.menuStrip1.ResumeLayout(false);
        this.menuStrip1.PerformLayout();
        this.ResumeLayout(false);
        this.PerformLayout();

    }
		#endregion

    float GetPixelsFromPoints(float points, float dpi) {
      return (dpi * points)/72f;
    }

    float GetInchesFromPoints(float points, float dpi) {
      return GetPixelsFromPoints(points, dpi)/dpi;
    }

    float GetPixelsFromDesignUnits(float designUnits, Font font, float dpi) {
      float scale = GetPixelsFromPoints(font.Size, dpi)/font.FontFamily.GetEmHeight(font.Style);
      return designUnits * scale;
    }

    float GetPointsFromPixels(float pixels, float dpi) {
      return (pixels*72f)/dpi;
    }

    private void FontSizes_Load(object sender, System.EventArgs e) {
      

      // A 12-point font will be 16 pixels high on a 96 dpi monitor
      //        float dpi = g.DpiY;
      //        float points = 12.0f;
      //        float pixels = (points * dpi)/72f;
      //        MessageBox.Show(pixels.ToString());

      // A 12-point font will be 16 pixels high on a 96 dpi monitor
      //        float points = 12.0f;
      //        float designUnits = 2048;
      //        float pixels = 

          UpdateListbox(this.Font);
          
      
    }

      private void chooseFontToolStripMenuItem_Click(object sender, EventArgs e)
      {
          using (FontDialog dlg = new FontDialog())
          {
              if (dlg.ShowDialog() == DialogResult.OK)
              {
                  UpdateListbox(dlg.Font);
              }
          }
      }

      private void Add(String format, params Object[] parms) {
          ListViewItem item = new ListViewItem("Hello");
          item.SubItems.Add("There");
          listBox1.Items.Add(item);
          //listBox1.Items.Add(string.Format(format, parms));
      }

      private void UpdateListbox(Font font)
      {
          using (Graphics g = this.CreateGraphics())
          {
              listBox1.Items.Clear();
              listBox1.Font = font;
              Add("{0,-33}{1}", "Font.Name=", font.Name);
              Add("{0,-33}{1} {2}s (specified Unit)", "font.Size=",
                  font.Size, font.Unit.ToString());
              Add("{0,-33}{1} Pixels", "font.Height=",
                  font.Height);
              Add("{0,-33}{1} Points", "font.GetHeight=",
                  font.GetHeight(g));
              Add("{0,-33}{1} Points", "font.SizeInPoints=",
                  font.SizeInPoints.ToString());
              Add("{0,-33}{1}", "GetPixels(font.SizeInPoints)",
                  GetPixelsFromPoints(font.SizeInPoints, g.DpiY));
              //        Add("GetInches(Font.SizeInPoints)=    {0} Inches", GetInchesFromPoints(font.SizeInPoints, g.DpiY));
              Add("{0,-33}{1}", "font.FontFamly.Name=",
                  font.FontFamily.Name);
              Add("{0,-33}{1} Design Units", "font.FontFamily.GetEmHeight=",
                  font.FontFamily.GetEmHeight(FontStyle.Regular));
              Add("{0,-33}{1} Points", "GetPixels(GetEmHeight)=",
                  GetPixelsFromDesignUnits(font.FontFamily.GetEmHeight(font.Style), font, g.DpiY));
              Add("{0,-33}{1} Design Units", "Font.FontFamily.GetLineSpacing=",
                  font.FontFamily.GetLineSpacing(FontStyle.Regular));
              Add("{0,-33}{1} Points", "GetPixels(GetLineSpacing)=",
                  GetPixelsFromDesignUnits(font.FontFamily.GetLineSpacing(font.Style), font, g.DpiY));
              Add("{0,-33}{1} Design Units", "font.FontFamily.GetCellAscent=",
                  font.FontFamily.GetCellAscent(FontStyle.Regular));
              Add("{0,-33}{1} Points", "GetPixels(GetCellAscent)=",
                  GetPixelsFromDesignUnits(font.FontFamily.GetCellAscent(font.Style), font, g.DpiY));
              Add("{0,-33}{1} Design Units", "font.FontFamily.GetCellDescent=",
                  font.FontFamily.GetCellDescent(FontStyle.Regular));
              Add("{0,-33}{1} Points", "GetPixels(GetCellDescent)=",
                  GetPixelsFromDesignUnits(font.FontFamily.GetCellDescent(font.Style), font, g.DpiY));
              Add("{0,-33}{1} Design Units", "Calculate Leading=",
                  font.FontFamily.GetLineSpacing(FontStyle.Regular) - (font.FontFamily.GetCellAscent(FontStyle.Regular) + font.FontFamily.GetCellDescent(FontStyle.Regular)));
              Add("{0,-33}{1} Points", "GetPixels(Leading)=",
                  GetPixelsFromDesignUnits(font.FontFamily.GetLineSpacing(FontStyle.Regular) - (font.FontFamily.GetCellAscent(FontStyle.Regular) + font.FontFamily.GetCellDescent(FontStyle.Regular)), font, g.DpiY));
          }
      }

  }

}
