using System;
using System.Drawing.Text;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Fonts
{
    /// <summary>
    /// Summary description for TextContrastForm.
    /// </summary>
    public class TextContrastForm : System.Windows.Forms.Form
    {
        private ToolStrip toolStrip1;
        private ToolStripTextBox toolStripTextBoxSize;
        private Panel panelDraw;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        public TextContrastForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //

            toolStripTextBoxSize.Text = ""+dFontSize;
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.toolStrip1 = new System.Windows.Forms.ToolStrip();
            this.toolStripTextBoxSize = new System.Windows.Forms.ToolStripTextBox();
            this.panelDraw = new System.Windows.Forms.Panel();
            this.toolStrip1.SuspendLayout();
            this.SuspendLayout();
            // 
            // toolStrip1
            // 
            this.toolStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripTextBoxSize});
            this.toolStrip1.Location = new System.Drawing.Point(0, 0);
            this.toolStrip1.Name = "toolStrip1";
            this.toolStrip1.Size = new System.Drawing.Size(292, 25);
            this.toolStrip1.TabIndex = 0;
            this.toolStrip1.Text = "toolStrip1";
            // 
            // toolStripTextBoxSize
            // 
            this.toolStripTextBoxSize.Name = "toolStripTextBoxSize";
            this.toolStripTextBoxSize.Size = new System.Drawing.Size(100, 25);
            this.toolStripTextBoxSize.MouseLeave += new System.EventHandler(this.toolStripTextBoxSize_MouseLeave);
            this.toolStripTextBoxSize.TextChanged += new System.EventHandler(this.toolStripTextBoxSize_TextChanged);
            // 
            // panelDraw
            // 
            this.panelDraw.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panelDraw.Location = new System.Drawing.Point(0, 25);
            this.panelDraw.Name = "panelDraw";
            this.panelDraw.Size = new System.Drawing.Size(292, 241);
            this.panelDraw.TabIndex = 1;
            this.panelDraw.MouseLeave += new System.EventHandler(this.panelDraw_MouseLeave);
            this.panelDraw.Paint += new System.Windows.Forms.PaintEventHandler(this.panelDraw_Paint);
            // 
            // TextContrastForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.Color.White;
            this.ClientSize = new System.Drawing.Size(292, 266);
            this.Controls.Add(this.panelDraw);
            this.Controls.Add(this.toolStrip1);
            this.Font = new System.Drawing.Font("Microsoft Sans Serif", 8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Name = "TextContrastForm";
            this.Text = "Text Contrasts";
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.TextContrastForm_Paint);
            this.toolStrip1.ResumeLayout(false);
            this.toolStrip1.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        void TextContrastForm_Paint(object sender, PaintEventArgs e)
        {
            
        }

        double dFontSize = 8;

        private void panelDraw_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            string s = @"Howdie, Partner";

            StringFormat format = new StringFormat();
            format.FormatFlags = StringFormatFlags.NoWrap;
            SizeF sz = g.MeasureString(String.Format("Contrast = {0:00}:", 0), this.Font);
            format.SetTabStops(0, new float[] { sz.Width, 0 });

            float y = 0;
            using (Font font = new Font(this.Font.FontFamily, (float)dFontSize))
            {
                for (int i = 0; i <= 12; i += 4)
                {
                    g.TextContrast = i;
                    string line = String.Format("Contrast = {0:00}:\t{1}", i, s);
                    g.DrawString(line, font, Brushes.Black, 0, y, format);
                    y += font.GetHeight(g) + 10;
                }
            }

        }

        private void panelDraw_MouseLeave(object sender, EventArgs e)
        {
            
        }

        private void toolStripTextBoxSize_MouseLeave(object sender, EventArgs e)
        {
            if (bSizeChanged)
            {
                double result = dFontSize;
                if (Double.TryParse(toolStripTextBoxSize.Text, out result))
                {
                    dFontSize = result;
                    Invalidate(true);
                    bSizeChanged = false;
                }
            }
        }

        bool bSizeChanged = false;
        private void toolStripTextBoxSize_TextChanged(object sender, EventArgs e)
        {
            bSizeChanged = true;
        }
    }
}
