using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TextRendererVsGraphics {
  public partial class ShellConsistencyForm : Form {

      private String Caption
      {
          get { return toolStripTextBoxCaption.Text; }
          set { 
              toolStripTextBoxCaption.Text = value;
              SetText(value);
          }
      }
      
    public ShellConsistencyForm() {
      InitializeComponent();
      label3.UseCompatibleTextRendering = true;
      Caption = "acgjqs";
    }

      private void SetText(String strText)
      {
          label3.Text = strText;
          textBox1.Text = strText;
          button1.Text = strText;
          button2.Text = strText;
      }

    private void gOKButton_Paint(object sender, PaintEventArgs e) {
      // Draw OK button using Graphics
      ButtonRenderer.DrawButton(e.Graphics, this.gOKButton.ClientRectangle, 
          System.Windows.Forms.VisualStyles.PushButtonState.Default);
      using (Font font = new Font("Tahoma", fFontSize))
      {
        StringFormat format = new StringFormat();
        format.Alignment = StringAlignment.Center;
        format.LineAlignment = StringAlignment.Center;
        e.Graphics.DrawString(Caption, font, Brushes.Black, 
            this.gOKButton.ClientRectangle, format);
      }
    }

      //int m_nFontSize = 16;
    private void gCancelButton_Paint(object sender, PaintEventArgs e) {
      // Draw Cancel button using Graphics
      ButtonRenderer.DrawButton(e.Graphics, this.gCancelButton.ClientRectangle, 
          System.Windows.Forms.VisualStyles.PushButtonState.Normal);
      using (Font font = new Font("Tahoma", fFontSize))
      {
        StringFormat format = new StringFormat();
        format.Alignment = StringAlignment.Center;
        format.LineAlignment = StringAlignment.Center;
        e.Graphics.DrawString("Cancel", font, Brushes.Black, 
            this.gCancelButton.ClientRectangle, format);
      }
    }

    private void tOKButton_Paint(object sender, PaintEventArgs e) {
      // Draw OK button using TextRenderer
      ButtonRenderer.DrawButton(e.Graphics, this.tOKButton.ClientRectangle, 
          System.Windows.Forms.VisualStyles.PushButtonState.Default);
      using( Font font = new Font("Tahoma", fFontSize) ) {
        TextFormatFlags format = TextFormatFlags.VerticalCenter | TextFormatFlags.HorizontalCenter;
        TextRenderer.DrawText(e.Graphics, Caption, font, 
            this.gCancelButton.ClientRectangle, this.ForeColor, format);
      }
    }

    private void tCancelButton_Paint(object sender, PaintEventArgs e) {
      // Draw Cancel button using TextRenderer
      ButtonRenderer.DrawButton(e.Graphics, this.tCancelButton.ClientRectangle, 
          System.Windows.Forms.VisualStyles.PushButtonState.Normal);
      using (Font font = new Font("Tahoma", fFontSize))
      {
        TextFormatFlags format = TextFormatFlags.VerticalCenter | TextFormatFlags.HorizontalCenter;
        TextRenderer.DrawText(e.Graphics, "Cancel", font, 
            this.gCancelButton.ClientRectangle, this.ForeColor, format);
      }
    }

      private void checkBoxCompatible_CheckedChanged(object sender, EventArgs e)
      {
          
      }



      bool bUpdate = false;
      private void toolStripTextBoxCaption_TextChanged(object sender, EventArgs e)
      {
          bUpdate = true;
      }

      private void toolStripTextBoxCaption_MouseLeave(object sender, EventArgs e)
      {
          if (bUpdate)
          {
              bUpdate = false;
              Caption = toolStripTextBoxCaption.Text;
              Invalidate(true);
          }
      }

      float fFontSize = 8.5f;
      private void trackBar1_ValueChanged(object sender, EventArgs e)
      {
          fFontSize = trackBar1.Value / 2f; 
          label3.Font = new Font(label3.Font.FontFamily, fFontSize);
          textBox1.Font = label3.Font;
          button1.Font = label3.Font;
          button2.Font = label3.Font;
          Invalidate(true);
      }

      private void buttonFont_Click(object sender, EventArgs e)
      {
          using (FontDialog dlg = new FontDialog())
          {
              dlg.Font = label3.Font;
              if (dlg.ShowDialog() == DialogResult.OK)
              {
                  label3.Font = dlg.Font;
                  textBox1.Font = label3.Font;
                  button1.Font = label3.Font;
                  button2.Font = label3.Font;
                  Invalidate(true);
              }
          }
      }
  }
}