﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using PageUnitsSample;
#endregion

namespace TransformsSample
{
    public partial class MainForm : System.Windows.Forms.Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void scalingButton_Click(object sender, EventArgs e)
        {
            OpenModal(Type.GetType("MatrixMarginsForm"));
        }

        private void scalingFontsButton_Click(object sender, EventArgs e)
        {
            OpenModal(typeof(ScalingFontsForm));
        }

        private void rotationButton_Click(object sender, EventArgs e)
        {
            OpenModal(typeof(RotateForm));
        }

        private void translationButton_Click(object sender, EventArgs e)
        {
            OpenModal(typeof(TranslationForm));
        }

        private void shearingButton_Click(object sender, EventArgs e)
        {
            OpenModal(typeof(ShearingForm));
        }

        private void pathTransformsButton_Click(object sender, EventArgs e)
        {
            OpenModal(typeof(PathFlattenForm));
        }

        private void pathTranslationButton_Click(object sender, EventArgs e)
        {
            OpenModal(typeof(PathTranslationForm));
        }

        private void helpButtonScaling_Click(object sender, EventArgs e)
        {
            using (PageUnitsSample.MainForm form = new PageUnitsSample.MainForm())
            {
                form.ShowDialog();
            }
        }

        private void helpButtonWarp_Click(object sender, EventArgs e)
        {
            OpenModal(typeof(TransformsSample.WarpForm));
        }

        private void OpenModal(Type type)
        {
            ////Get the generic type
            Type typeForm = Type.GetType(type.FullName, true);

            ////Create a concrete type given the generic type and the parameter
            //Type typeForm = typeGenList.MakeGenericType(type);

            using (Form form = Activator.CreateInstance(typeForm) as Form)
            {
                form.ShowDialog();
            }

        }
    }
}