﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

#endregion

namespace TransformsSample {
  partial class ScalingFontsForm : Form {
      Matrix m_matrix = new Matrix();
      StringFormat m_format = new StringFormat();
    public ScalingFontsForm() {
        InitializeComponent();
        m_format.Alignment = StringAlignment.Center;
        m_format.LineAlignment = StringAlignment.Center;
    }

    private void ScalingFontsForm_Paint(object sender, PaintEventArgs e) {
      Graphics g = e.Graphics;
      int y = 0;
      int width = this.ClientRectangle.Width / 4;
      int height = this.ClientRectangle.Height / 2;
      y = height;
      StringFormat format = new StringFormat();
      format.Alignment = StringAlignment.Center;
      format.LineAlignment = StringAlignment.Center;


        Point ptStart = new Point(0, 0);
        Size szRect = new Size(width, height);
        if (!centerToolStripMenuItem.Checked)
        {
            format.Alignment = StringAlignment.Near;
            format.LineAlignment = StringAlignment.Far;
        }
        transformFont(g, ref ptStart, new SizeF(1, 1), szRect, format);
        transformFont(g, ref ptStart, new SizeF(1, 3), szRect, format);
        transformFont(g, ref ptStart, new SizeF(2, 1), szRect, format);
        transformFont(g, ref ptStart, new SizeF(-1, -1), szRect, format);
        transformFont(g, ref ptStart, new SizeF(-1, -2), szRect, format);
        transformFont(g, ref ptStart, new SizeF(-2, 1), szRect, format);
        transformFont(g, ref ptStart, new SizeF(2, -1), szRect, format);
    }

      protected void transformFont(Graphics g, ref Point ptStart, SizeF szScale, Size szRect, StringFormat format)
      {
          g.ResetTransform();
          m_matrix.Reset();
          //matrix.Translate(fWidth, fHeight);
          m_matrix.Scale(szScale.Width, szScale.Height);
          g.Transform = m_matrix;
          RectangleF rectDraw = new RectangleF(
              ptStart.X / szScale.Width, ptStart.Y /szScale.Height,
              Math.Abs(szRect.Width / szScale.Width), Math.Abs(szRect.Height / szScale.Height));
          if (szScale.Width < 0)
          {
              rectDraw.Offset(szRect.Width / szScale.Width, 0f);
          }
          if (szScale.Height < 0)
          {
              rectDraw.Offset(0f, szRect.Height / szScale.Height);
          }
          g.DrawRectangle(Pens.Black, rectDraw.X, rectDraw.Y, rectDraw.Width, rectDraw.Height);
          String strScale = String.Format("Scale({0:F1}, {1:F1})", szScale.Width, szScale.Height);
          g.DrawString(strScale, this.Font, Brushes.Black, rectDraw, format);
          ptStart.X = (ptStart.X > this.ClientRectangle.Width - 2 * szRect.Width ? 0 : ptStart.X + szRect.Width);
          ptStart.Y = (ptStart.X == 0 ? ptStart.Y + szRect.Height : ptStart.Y);
      }

      private void centerToolStripMenuItem_Click(object sender, EventArgs e)
      {
          Invalidate(true);
      }
  }
}